<?php

/***************************************************************************\
 *  Module moteurinfos.php                                                *
 *   destination de                                                       *
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2005                                                     *
 *  Luc Perrey, luc.tech [at] free.fr                                                             *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
 *                                                                         *
 *  Historique :                                                           *
 *  2005/12/08, v0.4 : corrections liens moteur_infos                      *
 *  2005/12/07, v0.3 : renommage + precision moteurinfos pout fct _T       *
 *  2005/12/05, v0.2 : ajout textes, internationalisation                  *
 *  2005/12/02, v0.1 : creation                                            *
\***************************************************************************/
// ########################### parametrage debut ###########################
// Reindexation autorisee a tout le monde
// 1 : oui
// 0 : non (administrateur spip seulement)
$reidxredac=0;
// ########################### parametrage fin #############################

include ("inc.php");
include_ecrire ("inc_presentation.php");
include_ecrire ("inc_index.php");

//include_ecrire ("inc_admin.php");
//debut_page(_L('mi25_titre_module'), "administration", "cache");

debut_page(_T('moteurinfos:mi25_titre_module'), "", "");
echo "<br /><br />";
gros_titre(_T('moteurinfos:mi25_titre_module'));
echo "<br />";

// reindexation demandee
if ( isset($_GET['calc']) )
{
  indexer_article($_GET['calc']);
}

debut_gauche();


debut_boite_info();

     $query="select count(distinct id_article) cpt from spip_index_articles";
     $result=spip_query($query);
     $row = spip_fetch_array($result);
     echo $row['cpt']." "._T('moteurinfos:mi1_art_indexes')."<br />";

     $query="select count(distinct hash) cpt from spip_index_articles";
     $result=spip_query($query);
     $row = spip_fetch_array($result);
     echo $row['cpt']." "._T('moteurinfos:mi2_mots_indexes')."<br />";

     $query="select count(1) cpt from spip_index_articles";
     $result=spip_query($query);
     $row = spip_fetch_array($result);
     echo $row['cpt']." "._T('moteurinfos:mi3_enreg_tab')."<br />";


fin_boite_info();

debut_raccourcis();
echo "<ul>";
echo "<li><a href=\"moteurinfos.php\">"._T('moteurinfos:mi4_tous_art')."</a></li>";
echo "<li><a href=\"?sel=zero\">"._T('moteurinfos:mi5_sans_mot')."</a></li>";
echo "<li><a href=\"?idx=non\">"._T('moteurinfos:mi6_idx_cours')."</a></li>";
echo "<li><a href=\"?sel=nonpub\">"._T('moteurinfos:mi7_art_nonpub')."</a></li>";
echo "<li><a href=\"?sel=nonpubz\">"._T('moteurinfos:mi8_art_nonpub_mots')."</a></li>";
echo "<li><a href=\"admin_index.php\">"._T('moteurinfos:mi9_adm_index')."</a></li>";
echo "</ul>";
fin_raccourcis();


debut_droite();


$titre = _T('moteurinfos:mi10_list_art');

// Recuperation liste des articles
if ( $_GET['idx'] == "non" )
{
  $whereidx = "and a.idx != 'oui'";
  $titre = _T('moteurinfos:mi6_idx_cours');
  $texte = _T('moteurinfos:mi11_sans_mot_text');
}

$wherestatut="a.statut = 'publie'";
if ( $_GET['sel'] == "nonpub" )
{
  $wherestatut="a.statut != 'publie'";
  $titre = _T('moteurinfos:mi7_art_nonpub');
  $texte = _T('moteurinfos:mi12_art_nonpub_text');
}
if ( $_GET['sel'] == "nonpubz" )
{
  $wherestatut="a.statut != 'publie'";
  $titre = _T('moteurinfos:mi8_art_nonpub_mots');
  $texte = _T('moteurinfos:mi13_art_nonpub_mots_text');
}
$query = "SELECT a.id_article, a.titre titrea, r.titre titrer, a.idx
               FROM spip_articles a,
                    spip_rubriques r
               WHERE ${wherestatut} ${whereidx}
                 and a.id_rubrique = r.id_rubrique
               ORDER BY a.id_article";
//echo "$query";
$tranches = afficher_tranches_requete($query, 7);
$result = spip_query($query);

$tableau = '';
$i=0;
while ($row = spip_fetch_array($result)) {

     $squery="select count(1) cpt from spip_index_articles where id_article = ".$row['id_article'];
     $sresult=spip_query($squery);
     $srow = spip_fetch_array($sresult);
     // filtrage articles avec mots si sans mots demand
     if ( ($_GET['sel'] == "zero") && ( $srow['cpt'] != 0 ) ) {
                         $titre = _T('moteurinfos:mi5_sans_mot');
                         $texte = _T('moteurinfos:mi14_sans_mot_text');
                         continue;
                       }
     // filtrage articles sans mot indexe si sans mots non publi demand
     if ( ($_GET['sel'] == "nonpubz") && ( $srow['cpt'] == 0 ) ) {
                         continue;
                         }
     $i++;
     $vals = '';
     $vals[] = $row['id_article'];
     $vals[] = "<a href=\"articles.php?id_article=".$row['id_article']."\">".$row['titrea']."</a>";
     $vals[] = $row['titrer'];

     $vals[] = $srow['cpt'];
     spip_free_result($sresult);


     if ( $srow['cpt'] != 0 )
     {
     $lienvoir = "<a href=\"".$_SERVER['PHP_SELF']."?art=".$row['id_article'];
     foreach($_GET as $nom=>$val){
                   if ( ( $nom != "art" ) && ( $nom != "calc" ) )
                      {
                        $lienvoir .= "&${nom}=${val}";
                      }
                   //echo "_GET - $nom - $val <br />";
                 }
     $lienvoir .= "\">"._T('moteurinfos:mi15_voir')."</a>";
   }
   else
   {
     $lienvoir = "";
     }
    $vals[] = "${lienvoir}";
    
     $vals[] = ($row['idx']=="oui"?"non":"oui");   // si idx=oui alors non (indexation pas en cours)

     if ( (${cookie_admin}) || (${reidxredac}) )
     {
     $liencalc = "<a href=\"".$_SERVER['PHP_SELF']."?art=".$row['id_article']."&calc=".$row['id_article'];
     foreach($_GET as $nom=>$val){
                   if ( $nom != "art" )
                      {
                        $liencalc .= "&${nom}=${val}";
                      }
                   //echo "_GET - $nom - $val <br />";
                 }
     $liencalc .= "\">"._T('moteurinfos:mi16_recalc')."</a>";
    $reidxact = _T('moteurinfos:mi17_active');
   }
   else
   {
    $reidxact = _T('moteurinfos:mi18_inactive');
    $liencalc ="<i>"._T('moteurinfos:mi16_recalc')."</i>";
   }
    $vals[] = "${liencalc}";

     $tableau[] = $vals;
    //echo "<tr><td>$id - $titre </td></tr>";
    }
    spip_free_result($result);
    
// Affichage
debut_cadre_relief("", false, "", $titre );

echo "${texte}<br /><br />";

if ( $i != 0 )
{
        echo "<table style='border: 1px solid #aaaaaa;'>";
        echo $tranches;
        echo _T('moteurinfos:mi19_titretab');
        //afficher_liste_debut_tableau();
	$largeurs = array('','');
	$styles = array('','');
	afficher_liste($largeurs, $tableau, $styles);


    //afficher_liste_fin_tableau() ;
        echo "</table>";
echo "<br />";
echo _T('moteurinfos:mi20_infotab');

}
else
{
  echo "<b>"._T('moteurinfos:mi21_rienaffich')."</b>";
  echo "<br /><br />";
}

unset ($styles,$largeurs, $tableau, $tranches, $vals, ${liencalc},
$reidxact, $lienvoir, $sresult, $squery, $result, $query, $wherestatut, $titre, $texte );

fin_cadre_relief();



echo "<br />";

if ( isset($_GET['art']) ) {

debut_cadre_relief(  "", false, "", $titre = _T('moteurinfos:mi22_blmots_indexes'));

// Recuperations infos sur article selectionne
$query = "SELECT a.id_article, a.titre titrea, r.titre titrer FROM spip_articles a, spip_rubriques r WHERE a.id_article = ".$_GET['art']." and a.id_rubrique = r.id_rubrique";
$result = spip_query($query);
$row = spip_fetch_array( $result );
$id = $row['id_article'];
$titrea = $row['titrea'];
$titrer = $row['titrer'];
spip_free_result($result);

// Recuperation mots indexes
$query = "select dico, sum(points) as pts, count(1) as repetitions
           from spip_index_dico, spip_index_articles
           where spip_index_dico.hash = spip_index_articles.hash
                 and spip_index_articles.id_article = ".$_GET['art']."
                 group by spip_index_dico.hash
                 order by dico asc, pts desc" ;
$tableau = '';
$listemots = spip_query (${query}) ;
$i=0;
while( $mot = mysql_fetch_array( $listemots ))
 		{
		$i++;
                $vals = '';
                $vals[] = $mot['dico'];
                $vals[] = $mot['pts'];
                $vals[] = $mot['repetitions'];
                $tableau[] = $vals;
                 }
spip_free_result($listemots);

// Affichage  infos article
debut_boite_info();
echo "<b>$i</b> "._T('moteurinfos:mi23_blmots_indexes_art')." ${id} \"${titrea}\"";
fin_boite_info();
echo "<br />";
echo _T('moteurinfos:mi24_blmots_tabinfo');
echo "<br /><br />";


// Affichage  mots indexes

echo "<table style='border: 1px solid #aaaaaa;'>";

  echo _T('moteurinfos:mi24_blmots_tabentete');
	$largeurs = array('','');
	$styles = array('','');
	afficher_liste($largeurs, $tableau, $styles);
        echo "</table>";
fin_cadre_relief();

unset ($styles,$largeurs, $tableau, $tranches, $vals,$listemots, $titrea, $titrer, $id,
 $result, $query, $wherestatut, $titre, $texte );
}


fin_page();

?>